<?
   if(!isset($GLOBALS[__FILE__]))
   {
      $GLOBALS[__FILE__] = true;

      define("NOTE_A",       "A");
      define("NOTE_A_SHARP", "A#");
      define("NOTE_B_FLAT",  "Bb");
      define("NOTE_B",       "B");
      define("NOTE_C",       "C");
      define("NOTE_C_SHARP", "C#");
      define("NOTE_D_FLAT",  "Db");
      define("NOTE_D",       "D");
      define("NOTE_D_SHARP", "D#");
      define("NOTE_E_FLAT",  "Eb");
      define("NOTE_E",       "E");
      define("NOTE_F",       "F");
      define("NOTE_F_SHARP", "F#");
      define("NOTE_G_FLAT",  "Gb");
      define("NOTE_G",       "G");
      define("NOTE_G_SHARP", "G#");
      define("NOTE_A_FLAT",  "Ab");

      define("FRETBOARD_NFRETS",   24);
      define("FRETBOARD_NSTRINGS", 6);

      define("COLOR_GREY",  "777777");
      define("COLOR_BLACK", "000000");

      define("DISPLAY_MODE_SHARPS", "sharps");
      define("DISPLAY_MODE_FLATS",  "flats");

      error_reporting(-1);

      class Scales
      {
         function get()
         {
            return(
               array(
                  "Aeolian"             => "X XX X XX X ",
                  "Algerian"            => "X XX XXXX  X",
                  "Arabian"             => "X X XXX X X ",
                  "Arabian 8 Tone"      => "X XX XX XX X",
                  "Balinese"            => "XX X   XX   ",
                  "ChineseOne"          => "X X  X X X  ",
                  "ChineseTwo"          => "X   X XX   X",
                  "Chromatic"           => "XXXXXXXXXXXX",
                  "Diminished"          => "XX XX XX XX ",
                  "Diminished Arpeggio" => "X  X  X  X  ",
                  "Dorian"              => "X XX X X XX ",
                  "Double Harmonic"     => "XX  XX XX  X",
                  "Egyptian"            => "X X  X X  X ",
                  "Enigmatic"           => "XX  X X X XX",
                  "EthiopianOne"        => "X XX X X XX ",
                  "EthiopianTwo"        => "X X X XX X X",
                  "Harmonic Minor"      => "X XX X XX  X",
                  "Hawaiian"            => "X XX   X X X",
                  "Hirajoshi"           => "X XX   XX   ",
                  "Hindu"               => "X X XX XX X ",
                  "Hungarian Gypsy"     => "X XX  XXX X ",
                  "Hungarian Major"     => "X  XX XX XX ",
                  "Hungarian Minor"     => "X XX  XXX  X",
                  "Ionian"              => "X X XX X X X",
                  "Iwato"               => "XX   XX   X ",
                  "Javanese"            => "XX X X X XX ",
                  "Jewish"              => "X X XX  XX X",
                  "Kokinjoshi"          => "XX   X X  X ",
                  "Kumoi"               => "XX   X XX   ",
                  "Leading Whole Tone"  => "X X X X X XX",
                  "Locrian"             => "XX X XX X X ",
                  "Lydian"              => "X X X XX X X",
                  "Lydian Minor"        => "X X X XXX X ",
                  "Major"               => "X X XX X X X",
                  "Major Locrian"       => "X X XXX X X ",
                  "Melodic Minor"       => "X XX X X X X",
                  "Minor"               => "X XX X XX X ",
                  "Mixolydian"          => "X X XX X XX ",
                  "Mongolian"           => "X X X  X X  ",
                  "Neapolitan Major"    => "XX X X X X X",
                  "Neapolitan Minor"    => "XX X X XX  X",
                  "Oriental"            => "XX  XXX  XX ",
                  "Overrtone"           => "X X X XX XX ",
                  "Pelog"               => "XX X   X  X ",
                  "Pentatonic Minor"    => "X  X X X  X ",
                  "Persian"             => "XX  XXX X  X",
                  "Phrygian"            => "XX X X XX X ",
                  "Prometheus"          => "X X X X   X ",
                  "Spanish 8 Tone"      => "XX XXXX X X ",
                  "Spanish Gypsy"       => "XX  XX XX X ",
                  "UnknownOne"          => "XX X XX XX  ",
                  "UnknownTwo"          => "X XX XX XX  ",
                  "Whole Tone"          => "X X X X X X "
               )
            );
         }

         function getRequest()
         {
            if(isset($GLOBALS["_REQUEST"]))
               return($GLOBALS["_REQUEST"]);

            return(array());
         }

         function getRequestValue($name)
         {
            $request = Scales::getRequest();

            return(isset($request[$name]) ? trim($request[$name]) : "");
         }
      }

      class Chords
      {
         function get()
         {
            return(
               array(
                  "Major Chord"         => "X   X  X    ",
                  "Major Sus4 Chord"    => "X    X X    ",
                  "Major 6 Chord"       => "X   X  X X  ",
                  "Major 6/9 Chord"     => "X X X  X X  ",
                  "Major 7 Chord"       => "X   X  X   X",
                  "Major 9 Chord"       => "X X X  X   X",
                  "Minor Chord"         => "X  X   X    ",
                  "Minor 6 Chord"       => "X  X   X X  ",
                  "Minor 7 Chord"       => "X  X   X  X ",
                  "Minor (maj 7) Chord" => "X  X   X   X",
                  "Minor 9 Chord"       => "X XX   X  X ",
                  "Minor 11 Chord"      => "X  X X X  X ",
                  "Minor 13 Chord"      => "X  X   X XX ",
                  "Minor 7b5 Chord"     => "X  X  X   X ",
                  "7(o) Chord"          => "X  X  X  X  ",
                  "7 Chord"             => "X   X  X  X ",
                  "7 sus4   Chord"      => "X    X X  X ",
                  "7b5 Chord"           => "X   X X   X ",
                  "7#5 Chord"           => "X   X   X X ",
                  "9 Chord"             => "X X X  X  X ",
                  "9 sus4 Chord"        => "X X  X    X ",
                  "9b5 Chord"           => "X X X X   X ",
                  "9#5 Chord"           => "X X X   X X ",
                  "13 Chord"            => "X   X  X XX "
               )
            );
         }
      }

      class Notes
      {
         function get($displayMode)
         {
            $notes = array(
               DISPLAY_MODE_SHARPS =>
               array(
                  NOTE_A,       NOTE_A_SHARP,  NOTE_B,       NOTE_C,
                  NOTE_C_SHARP, NOTE_D,        NOTE_D_SHARP, NOTE_E,
                  NOTE_F,       NOTE_F_SHARP,  NOTE_G,       NOTE_G_SHARP
               ),
               DISPLAY_MODE_FLATS =>
               array(
                  NOTE_A,       NOTE_B_FLAT,  NOTE_B,      NOTE_C,
                  NOTE_D_FLAT,  NOTE_D,       NOTE_E_FLAT, NOTE_E,
                  NOTE_F,       NOTE_G_FLAT,  NOTE_G,      NOTE_A_FLAT
               )
            );

            return($notes[$displayMode]);
         }

         function getOffset($theNote, $displayMode)
         {
            $notes  = Notes::get($displayMode);
            $nNotes = count($notes);

            for($i = 0; $i < $nNotes; $i ++)
               if($theNote == $notes[$i])
                  return($i);

            return(-1);
         }
      }

      class FretBoardData
      {
         var $title = false;

         function FretBoardData($title) { $this->title = $title; }
         function getTitle()            { return($this->title);  }

         function displayNote($theNote, $stringNumber, $fretNumber)
         {
            return(true);
         }
      }

      class PatternHandler
      {
         function process(
            &$clientData,
            &$patternNotes,
            $key,
            $pattern,
            $displayMode,
            $noteCallback
         )
         {
            $notes         = Notes::get($displayMode);
            $patternLength = strlen($pattern);
            $first         = true;
            $patternNotes  = "(";
            $noteOffset    = Notes::getOffset($key, $displayMode);

            for($i = 0; $i < $patternLength; $i ++)
            {
               $c = substr($pattern, $i, 1);

               if($c == "X")
               {
                  $thisNote = $notes[($i + $noteOffset) % $patternLength];

                  if($first)
                     $first = false;
                  else
                     $patternNotes .= ", ";

                  $patternNotes .= $thisNote;

                  $noteCallback($clientData, $thisNote);
               }
            }

            $patternNotes .= ")";
         }
      }

      class ScaleFretBoardData extends FretBoardData
      {
         var $title        = false;
         var $notesInScale = false;
         
         function ScaleFretBoardData(
            $key,
            $scaleName,
            $scalePattern,
            $displayMode,
            $titlePrefix = "Key of "
         )
         {
            $this->title   = "$titlePrefix $key $scaleName ";
            $this->first   = true;

            function ScaleFretBoardCallback(&$clientData, $thisNote)
            {
               $clientData->notesInScale[$thisNote] = true;
            }

            $patternNotes = "";

            PatternHandler::process(
               $this,
               $patternNotes,
               $key,
               $scalePattern,
               $displayMode,
               "ScaleFretBoardCallback"
            );

            $this->title .= $patternNotes;
         }

         function displayNote($theNote, $stringNumber, $fretNumber)
         {
            return(isset($this->notesInScale[$theNote]));
         }
      }

      class FretBoard
      {
         function getOpenStrings()
         {
            // The open strings, from the lowest note to the highest

            return(
               array(
                  NOTE_E, NOTE_A, NOTE_D, NOTE_G, NOTE_B, NOTE_E
               )
            );
         }

         function draw($data, $displayMode)
         {
            print(
               "<div align=\"center\">" . $data->getTitle() . "</div>\n" .
               "<p>\n" .
               "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\">\n"
            );

            $openStrings  = FretBoard::getOpenStrings();
            $nStrings     = count($openStrings);
            $notes        = Notes::get($displayMode);
            $nNotes       = count($notes);
            $stringNumber = FRETBOARD_NSTRINGS - 1;

            for($i = 0; $i < $nStrings; $i ++, $stringNumber --)
            {
               // We draw the strings from top to bottom ...

               $thisString = $openStrings[$stringNumber];

               print("<tr>\n");

               $noteOffset = Notes::getOffset($thisString, $displayMode);

               for($j = 0; $j <= FRETBOARD_NFRETS; $j ++)
               {
                  $thisNote = $notes[($noteOffset + $j) % $nNotes];
                  $value    = "----";

                  if($data->displayNote($thisNote, $stringNumber, $j))
                  {
                     $value = "-$thisNote-";

                     if(strlen($value) < 4)
                        $value .= "-";
                  }

                  print(
                     " <td><tt>$value</tt></td>\n"
                  );

                  $color = COLOR_GREY;

                  if($j % 12 == 0 || $j % 12 == 11)
                     $color = COLOR_BLACK;

                  print(
                     " <td bgcolor=\"#$color\">" .
                     "<font color=\"#$color\">|</font>" .
                     "</td>\n"
                  );
               }

               print("</tr>\n");
            }

            print("<tr>\n");

            for($i = 0; $i <= FRETBOARD_NFRETS; $i ++)
            {
               $fretNumber = "&nbsp;$i";

               while(strlen($fretNumber) < 4)
                  $fretNumber .= "&nbsp;";

               print(
                  " <td><tt>$fretNumber</tt></td><td></td>\n"
               );
            }

            print("</tr>\n");

            print(
               "</table>\n"
            );
         }
      }
   }
?>
